window.onload = function()
{
  /*globalStorage['localhost'].lastsaved = "testing"*/

	document.gradebook.onsubmit = submitForm;
	document.gradebook.onchange = submitForm;
  //document.gradebook.getElementById('gradebook').onchange = submitForm;
  
  if(document.cookie) {
    importData(readCookie("Grade_Book"));
  }
  /*
  if(globalStorage.gradebook) {
    alert(globalStorage.gradebook);
  }
  */
	submitForm();
}

function el(id) 
{ 
 if (document.getElementById) { 
   return document.getElementById(id); 
 } else if (window[id]) { 
   return window[id]; }
 return null;
}

function importFile() 
{
  alert("Not ready yet");
}


var alphabet = "_ABCDEFGHIJKLMNOPQRSTUVWXYZ"
var total_assignments = 1; //total number of class assignments
var total_students = 1; //total number of students in class


function submitForm()
{ 
  for (j = 1; j <= total_students; j++) {
    var points = 0; //stores running point total for student grade
    var points_Max = 0; //store running point total for student max grade
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      if (el(alphabet[i]+j).value != "EXC") {
        points += eval(el(alphabet[i]+j).value);
        points_Max += eval(el(alphabet[i]+"_Max").value);
      }
    }
    
    var percent = (points_Max == 0) ? 100 : points / points_Max * 100;
    el("Percent_"+j).innerHTML = Math.round(percent*100)/100 + "%"; //parseInt(percent);
    
  }

  updateArrays();
}


var data = new Array();
var info = new Array();
info[0] = ["Untitled","Teacher Name"]
info[1] = ["1/1/08","T1","Test 1","T"]

function packageArrays()
{
  var save1 = new Array();
  var save2 = new Array();
  for (i=0; i < data.length; i++) {
    save1[i] = data[i].join("|");
  }
  for (i=0; i < info.length; i++) {
    save2[i] = info[i].join("|");
  }
  return save1.join("\n")+"\n***\n"+save2.join("\n");
}

function processFile(file)
{
  info = [0] //initialize
  data = [0] //initialize
  var split0 = file.split("\n***\n");
  var split1 = split0[0].split("\n");
  var split2 = split0[1].split("\n");
  for (i=0; i < split1.length; i++) {
    data[i] = split1[i].split("|");
  }
  for (i=0; i < split2.length; i++) {
    info[i] = split2[i].split("|");
  }
}

function updateArrays()
{
  // Max points for each assignment
  var assignments = new Array();
  assignments[0] = " ";
  data = [0] //initialize
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]+"_Max").value;
  }
  data[0] = assignments;
  
  // Student points for each assignment
  for (j = 1; j <= total_students; j++) {
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      assignments[i] = el(alphabet[i]+j).value;
    }
  
    data[j] = assignments;
  }

  // Assignment titles
  for (i = 1; i <= total_assignments; i++) {
    info[i][1] = el(alphabet[i]).value;
  }
  
  // Save changes
  save()
}

function save()
{
  el("file").value = packageArrays();
  updateCookie(packageArrays());
  //globalStorage.gradebook = save.join("\n");
}

//var save = new Array();
/*
function exportData()
{
  // Max points for each assignment
  var assignments = new Array();
  assignments[0] = " ";
  data = [0] //initialize
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]+"_Max").value;
  }
  data[0] = assignments;
  save[0] = assignments.join("|");
  
  // Student points for each assignment
  for (j = 1; j <= total_students; j++) {
    var assignments = new Array(); //stores grades for one student's assignments
    assignments[0] = el("Student_"+j).value; //stores the sudents name to assignments[0]
    
    for (i = 1; i <= total_assignments; i++) {
      assignments[i] = el(alphabet[i]+j).value;
    }
    
    data[j] = assignments;
    save[j] = assignments.join("|");
  }

  // Assignment titles
  var assignments = new Array();
  assignments[0] = "zzTitles";
  
  for (i = 1; i <= total_assignments; i++) {
    assignments[i] = el(alphabet[i]).value;
  }
  data[total_students+1] = assignments;
  save[total_students+1] = assignments.join("|");
  
  
  el("file").value = save.join("\n");
  updateCookie(save.join("\n"));
  //globalStorage.gradebook = save.join("\n");
}
*/

function importData(file)
{
  if (file=="") { file = "Max|100\nJoe|92\nTitles|T1\n***\n\n1/1/08|T1|Test 1|T"; }
  if (file) {
    // Process file
    processFile(file);
  }
  
  // Add new rows to table if needed
  while (total_students < data.length-1) {
    total_students += 1;
    addRow();
  }
  if (total_students > data.length-1) {
    total_students = data.length-1;
  }
  
  // Add new columns to table if needed
  while (total_assignments < info.length-1) {
    total_assignments += 1;
    addCol();
  }
  if (total_assignments > info.length-1) {
    total_assignments = info.length-1
  }
  

  // Update max points display
  for (i = 1; i <= total_assignments; i++) {
    el(alphabet[i]+"_Max").value = data[0][i];
  }
  
  // Update student points for each assignment
  for (j = 1; j <= total_students; j++) {
    el("Student_"+j).value = data[j][0]; //stores the sudents name to assignments[0]
    for (i = 1; i <= total_assignments; i++) {
      el(alphabet[i]+j).value = data[j][i]
    }
  }
  
  //Update titles for each assignment
  for (i = 1; i <= total_assignments; i++) {
    el(alphabet[i]).value = info[i][1];
  }
  
  //Update caluculations
  submitForm();
}
    
function addStudent()
{ 
  total_students += 1;
  addRow();
  importData();
  total_students += 1; //importData() resets total_students
  el("Student_"+total_students).focus();
  el("Student_"+total_students).select();
}

function addRow()
{
  var newHTML = '\n<tr>\n'
       + '<th><input type="text" value="New Student" id="Student_' + total_students + '" size="15" /></th>\n'
       + '<td class="noedit"><span id="Percent_' + total_students + '">%</span></td>\n';
  for (i = 1; i <= total_assignments; i++) {
    newHTML += '<td><input type="text" value="" id="' + alphabet[i] + total_students + '" size="3" /></td>\n';
  }
  newHTML += '</tr>\n';
  el("gradebooktable").innerHTML += newHTML;
}

function newAssignmentDialog()
{
  var date = new Date();
  var year = date.getYear()+"";
  el("date").value = (date.getMonth()+1) + "/" + date.getDate() + "/" + year.substring(year.length-2,year.length);
  
  el("assignment").style.display = "block";
  el("assignment").onsubmit = addAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function addAssignment()
{
  total_assignments += 1;
  
  var title_info = new Array();
  title_info[0] = el("date").value;
  title_info[1] = el("abbr_title").value;
  title_info[2] = el("full_title").value;
  title_info[3] = el("type").value;
  info[total_assignments] = title_info;
  save();
  el("assignment").style.display = "none"; 

  addCol()
  importData();
  total_assignments += 1; //importData()resets total_assignments
}

function addCol()
{
  var newHTML = el("gradebooktable").innerHTML.split("</tr>");
  newHTML[0] += '<th><input value="' + info[total_assignments][1] + '" title="' + info[total_assignments][2]
          + '" id="' + alphabet[total_assignments] + '" size="3" type="text"></th>\n';
  newHTML[1] += '<td><input type="text" value="100" id="' + alphabet[total_assignments] + '_Max" size="3" /></td>\n';
  for (i = 1; i < newHTML.length-2; i++) {
    newHTML[i+1] += '<td><input type="text" value="" id="' + alphabet[total_assignments] + i +'" size="3" /></td>\n';
  }
  el("gradebooktable").innerHTML = newHTML.join("</tr>");
}

function fullIndividualReports()
{
  var newHTML  = '<?xml version="1.0" encoding="UTF-8"?>\n'
          + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\n'
          + '   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n'
          + '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >\n'
          + '<head><title>' + info[0][1] + ': ' + info[0][0] + '</title>' // Teacher and class name
          + '<style type="text/css">td {padding-right:4em} th {text-align:left}</style></head>\n'
          + '<body onload="window.print()">\n';
  
  for (j = 1; j <= total_students; j++) {
  
    // Add student name, and table headings
    newHTML  += "\n<h1>" + data[j][0] + "</h1>\n" // Student name
          + '<table><tr><th>Title</th><th>Type</th><th>Date</th><th>Grade</th></tr>\n';
    
    // Add student data for every assignment 
    for (i = 1; i <= total_assignments; i++) {
      newHTML += "<tr>\n<td>" + info[i][2] //full title of assignment
          + "</td><td>" + info[i][3] //type
          + "</td><td>" + info[i][0] //date
          + "</td><td>" + data[j][i] //grade
          + " / " + data[0][i] + "</td></tr>\n"; //max points
    }
    
    // Calculate letter grade
    var percent = el("Percent_"+j).innerHTML;
    percent = percent.substring(0,percent.length-1);
    var letter = getLetterGrade(percent);
    
    // Add overall grade
    newHTML += '</table>\n\n'
          + '<p style="page-break-after:always"><strong>Overall Grade: ' + percent + '% ' + letter + '</strong></p>\n\n';
  }
  newHTML += "</body>\n</html>";
  
  document.writeln(newHTML);
  document.close();
}

function getLetterGrade(percent)
{
  var grade; 
  
  if (percent >= 95) grade = "A"
  else if (percent >= 90) grade = "A-"
  else if (percent >= 87) grade = "B+"
  else if (percent >= 83) grade = "B"
  else if (percent >= 80) grade = "B-"
  else if (percent >= 77) grade = "C+"
  else if (percent >= 73) grade = "C"
  else if (percent >= 70) grade = "C-"
  else if (percent >= 67) grade = "D+"
  else if (percent >= 63) grade = "D"
  else if (percent >= 60) grade = "D-"
  else grade = "F";
  
  return grade;
}

function showFileSummary()
{
  el("class_title").value = info[0][0];
  el("teacher").value = info[0][1];
  el("file_summary").style.display = "block";
  el("file_summary").onsubmit = saveFileSummary;
  el("class_title").focus();
  el("class_title").select();
}
function saveFileSummary()
{
  info[0] = [el('class_title').value , el('teacher').value];
  save();
}